<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Processors/SXRCompiler.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Processors/SXRCompiler.py</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Processors/SXRCompiler.py</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="py-comment"># Copyright (C) 2008 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno"> 7</span>
<a id="line8"></a><span class="lineno"> 8</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> SXR</span>
<a id="line9"></a><span class="lineno"> 9</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> *</span>
<a id="line10"></a><span class="lineno">10</span><span class="line"><span class="py-keyword">from</span> Synopsis.QualifiedName <span class="py-keyword">import</span> *</span>
<a id="line11"></a><span class="lineno">11</span><span class="line"><span class="py-keyword">from</span> xml.dom.minidom <span class="py-keyword">import</span> parse</span>
<a id="line12"></a><span class="lineno">12</span><span class="line"><span class="py-keyword">import</span> os.path</span>
<a id="line13"></a><span class="lineno">13</span>
<a id="line14"></a><span class="lineno">14</span><span class="line"><span class="py-keyword">class</span> <a href="../../../Scopes/Synopsis/Processors/SXRCompiler/SXRCompiler.html">SXRCompiler</a>(Processor):</span>
<a id="line15"></a><span class="lineno">15</span><span class="line">    <span class="py-string">&quot;&quot;&quot;This class compiles symbol references stored in sxr files into a single symbol table.&quot;&quot;&quot;</span></span>
<a id="line16"></a><span class="lineno">16</span>
<a id="line17"></a><span class="lineno">17</span><span class="line">    prefix = Parameter(<span class="py-string">''</span>, <span class="py-string">'where to look for sxr files'</span>)</span>
<a id="line18"></a><span class="lineno">18</span><span class="line">    no_locals = Parameter(True, <span class="py-string">''</span>)</span>
<a id="line19"></a><span class="lineno">19</span>
<a id="line20"></a><span class="lineno">20</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/SXRCompiler/SXRCompiler.html#process">process</a>(self, ir, **kwds):</span>
<a id="line21"></a><span class="lineno">21</span>
<a id="line22"></a><span class="lineno">22</span><span class="line">        self.set_parameters(kwds)</span>
<a id="line23"></a><span class="lineno">23</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.prefix: <span class="py-keyword">raise</span> MissingArgument(<span class="py-string">'prefix'</span>)</span>
<a id="line24"></a><span class="lineno">24</span><span class="line">        self.ir = self.merge_input(ir)</span>
<a id="line25"></a><span class="lineno">25</span>
<a id="line26"></a><span class="lineno">26</span><span class="line">        <span class="py-keyword">def</span> prefix(filename):</span>
<a id="line27"></a><span class="lineno">27</span><span class="line">            <span class="py-string">&quot;Map filename to sxr filename.&quot;</span></span>
<a id="line28"></a><span class="lineno">28</span>
<a id="line29"></a><span class="lineno">29</span><span class="line">            <span class="py-comment"># Even though filenames shouldn't be absolute, we protect ourselves</span></span>
<a id="line30"></a><span class="lineno">30</span><span class="line">            <span class="py-comment"># against accidents.</span></span>
<a id="line31"></a><span class="lineno">31</span><span class="line">            <span class="py-keyword">if</span> os.path.isabs(filename):</span>
<a id="line32"></a><span class="lineno">32</span><span class="line">                filename = os.path.splitdrive(filename)[1][1:]</span>
<a id="line33"></a><span class="lineno">33</span><span class="line">            <span class="py-keyword">return</span> os.path.join(self.prefix, filename) + <span class="py-string">'.sxr'</span></span>
<a id="line34"></a><span class="lineno">34</span>
<a id="line35"></a><span class="lineno">35</span><span class="line">        <span class="py-keyword">for</span> f <span class="py-keyword">in</span> self.ir.files.values():</span>
<a id="line36"></a><span class="lineno">36</span><span class="line">            <span class="py-keyword">if</span> f.annotations[<span class="py-string">'primary'</span>] <span class="py-keyword">and</span> os.path.exists(prefix(f.name)):</span>
<a id="line37"></a><span class="lineno">37</span><span class="line">                self.compile(prefix(f.name), f.annotations[<span class="py-string">'language'</span>])</span>
<a id="line38"></a><span class="lineno">38</span>
<a id="line39"></a><span class="lineno">39</span><span class="line">        self.ir.sxr.generate_index()</span>
<a id="line40"></a><span class="lineno">40</span>
<a id="line41"></a><span class="lineno">41</span><span class="line">        <span class="py-keyword">return</span> self.ir</span>
<a id="line42"></a><span class="lineno">42</span>
<a id="line43"></a><span class="lineno">43</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/SXRCompiler/SXRCompiler.html#compile">compile</a>(self, filename, language):</span>
<a id="line44"></a><span class="lineno">44</span>
<a id="line45"></a><span class="lineno">45</span><span class="line">        <span class="py-keyword">if</span> language == <span class="py-string">'Python'</span>:</span>
<a id="line46"></a><span class="lineno">46</span><span class="line">            QName = <span class="py-keyword">lambda</span> name: QualifiedPythonName(str(name).split(<span class="py-string">'.'</span>))</span>
<a id="line47"></a><span class="lineno">47</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line48"></a><span class="lineno">48</span><span class="line">            QName = <span class="py-keyword">lambda</span> name: QualifiedCxxName(str(name).split(<span class="py-string">'::'</span>))</span>
<a id="line49"></a><span class="lineno">49</span>
<a id="line50"></a><span class="lineno">50</span>
<a id="line51"></a><span class="lineno">51</span><span class="line">        <span class="py-keyword">if</span> self.verbose: <span class="py-keyword">print</span> <span class="py-string">&quot;SXRCompiler: Reading&quot;</span>, filename</span>
<a id="line52"></a><span class="lineno">52</span><span class="line">        <span class="py-keyword">try</span>:</span>
<a id="line53"></a><span class="lineno">53</span><span class="line">            document = parse(filename)</span>
<a id="line54"></a><span class="lineno">54</span><span class="line">        <span class="py-keyword">except</span>:</span>
<a id="line55"></a><span class="lineno">55</span><span class="line">            <span class="py-keyword">if</span> self.debug:</span>
<a id="line56"></a><span class="lineno">56</span><span class="line">                <span class="py-keyword">print</span> <span class="py-string">'Error parsing'</span>, filename</span>
<a id="line57"></a><span class="lineno">57</span><span class="line">                <span class="py-keyword">raise</span></span>
<a id="line58"></a><span class="lineno">58</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line59"></a><span class="lineno">59</span><span class="line">                <span class="py-keyword">raise</span> InternalError(<span class="py-string">'parsing %s'</span>%filename)</span>
<a id="line60"></a><span class="lineno">60</span><span class="line">        sxr = document.documentElement</span>
<a id="line61"></a><span class="lineno">61</span><span class="line">        filename = sxr.getAttribute(<span class="py-string">'filename'</span>)</span>
<a id="line62"></a><span class="lineno">62</span><span class="line">        lines = sxr.getElementsByTagName(<span class="py-string">'line'</span>)</span>
<a id="line63"></a><span class="lineno">63</span><span class="line">        <span class="py-keyword">for</span> lineno, line <span class="py-keyword">in</span> enumerate(lines):</span>
<a id="line64"></a><span class="lineno">64</span><span class="line">            <span class="py-keyword">for</span> a <span class="py-keyword">in</span> line.getElementsByTagName(<span class="py-string">'a'</span>):</span>
<a id="line65"></a><span class="lineno">65</span><span class="line">                <span class="py-keyword">if</span> a.getAttribute(<span class="py-string">'continuation'</span>) == <span class="py-string">'true'</span>:</span>
<a id="line66"></a><span class="lineno">66</span><span class="line">                    <span class="py-keyword">continue</span></span>
<a id="line67"></a><span class="lineno">67</span><span class="line">                qname = QName(a.getAttribute(<span class="py-string">'href'</span>))</span>
<a id="line68"></a><span class="lineno">68</span><span class="line">                origin = QName(a.getAttribute(<span class="py-string">'from'</span>))</span>
<a id="line69"></a><span class="lineno">69</span><span class="line">                type = str(a.getAttribute(<span class="py-string">'type'</span>))</span>
<a id="line70"></a><span class="lineno">70</span><span class="line">                <span class="py-keyword">if</span> self.no_locals:</span>
<a id="line71"></a><span class="lineno">71</span><span class="line">                    bad = False</span>
<a id="line72"></a><span class="lineno">72</span><span class="line">                    <span class="py-keyword">for</span> i <span class="py-keyword">in</span> range(len(qname)):</span>
<a id="line73"></a><span class="lineno">73</span><span class="line">                        <span class="py-keyword">if</span> len(qname[i]) &gt; 0 <span class="py-keyword">and</span> qname[i][0] == <span class="py-string">'`'</span>:</span>
<a id="line74"></a><span class="lineno">74</span><span class="line">                            <span class="py-comment"># Don't store local function variables</span></span>
<a id="line75"></a><span class="lineno">75</span><span class="line">                            bad = True</span>
<a id="line76"></a><span class="lineno">76</span><span class="line">                            <span class="py-keyword">break</span></span>
<a id="line77"></a><span class="lineno">77</span><span class="line">                    <span class="py-keyword">if</span> bad: <span class="py-keyword">continue</span></span>
<a id="line78"></a><span class="lineno">78</span>
<a id="line79"></a><span class="lineno">79</span><span class="line">                    <span class="py-keyword">for</span> i <span class="py-keyword">in</span> range(len(origin)):</span>
<a id="line80"></a><span class="lineno">80</span><span class="line">                        <span class="py-keyword">if</span> len(origin[i]) &gt; 0 <span class="py-keyword">and</span> origin[i][0] == <span class="py-string">'`'</span>:</span>
<a id="line81"></a><span class="lineno">81</span><span class="line">                            <span class="py-comment"># Function scope, truncate here</span></span>
<a id="line82"></a><span class="lineno">82</span><span class="line">                            origin = origin[:i] + (origin[i][1:],)</span>
<a id="line83"></a><span class="lineno">83</span><span class="line">                            <span class="py-keyword">break</span></span>
<a id="line84"></a><span class="lineno">84</span><span class="line">                entry = self.ir.sxr.setdefault(qname, SXR.Entry())</span>
<a id="line85"></a><span class="lineno">85</span><span class="line">                <span class="py-keyword">if</span> type == <span class="py-string">'definition'</span>:</span>
<a id="line86"></a><span class="lineno">86</span><span class="line">                    entry.definitions.append((filename, lineno + 1, origin))</span>
<a id="line87"></a><span class="lineno">87</span><span class="line">                <span class="py-keyword">elif</span> type == <span class="py-string">'call'</span>:</span>
<a id="line88"></a><span class="lineno">88</span><span class="line">                    entry.calls.append((filename, lineno + 1, origin))</span>
<a id="line89"></a><span class="lineno">89</span><span class="line">                <span class="py-keyword">elif</span> type == <span class="py-string">'reference'</span>:</span>
<a id="line90"></a><span class="lineno">90</span><span class="line">                    entry.references.append((filename, lineno + 1, origin))</span>
<a id="line91"></a><span class="lineno">91</span><span class="line">                <span class="py-keyword">else</span>:</span>
<a id="line92"></a><span class="lineno">92</span><span class="line">                    <span class="py-keyword">print</span> <span class="py-string">'Warning: Unknown sxr type in %s:%d : %s'</span>%(filename, lineno + 1, type)</span>
<a id="line93"></a><span class="lineno">93</span>
<a id="line94"></a><span class="lineno">94</span>
<a id="line95"></a><span class="lineno">95</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:15 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
